module Optimizer where

import Syntax
import Context

pass1 :: Document -> Document

pass1 = map (myPass emptyContext)

myPass :: Context -> El -> El
myPass ct Ws			= Ws
myPass ct t@(Txt _)		= t
myPass c1 (Tag t [e])		=
	let c2 	= enterTag c1 t
	    (c,b)	= myPassS c1 c2 e
	in if b then c else (Tag t [c])
	
myPass ct x@(Tag t _)		= 
	let ct' = enterTag ct t
	in myPass' ct' x

myPass' ct' (Tag t doc) =
	Tag t (map (myPass ct') doc)

myPassS :: Context -> Context -> El -> (El, Bool)
myPassS c1 c2 Ws		= (Ws, c1==c2)
myPassS c1 c2 t@(Txt _)         = (t,c1==c2)
myPassS c1 c2 x@(Tag t _) 	= 
	let c1' 	= enterTag c1 t
	    c2' 	= enterTag c2 t
	in (myPass' c2' x,  c1'== c2')
	    
	    
